#include <htc.h>
#include <string.h>
#include <stdio.h>
#include "./usart/serial.h"


//

#define _XTAL_FREQ 8000000
//__CONFIG(1,IESODIS&HSPLL&FCMDIS);
__CONFIG(1,HS&IESODIS&FCMDIS);
__CONFIG(2,BOREN&BORV27&PWRTEN&WDTPS1&WDTDIS);
__CONFIG(3,MCLREN&CCP2RC1&PBDIGITAL);
__CONFIG(4,XINSTDIS&DEBUGDIS&LVPDIS&STVRDIS);
__CONFIG(5,UNPROTECT);
__CONFIG(6,UNPROTECT);
__CONFIG(7,UNPROTECT);

#include "pff.h"
//#include "lcd3310.h"

FATFS Fs;			/* File system object */
DIR Dir;			/* Directory object */
FILINFO Fno;		/* File information */

WORD rb;			/* Return value. */
BYTE buff[100];

void delay(void);

void main(void)
{
	BYTE res, i;
    init_comms();   
	//lcd_init();
   
	while(1){

	     delay();
		//lcd_clear();
		//lcd_text(0,3, "insert card!");
		printf( "insert card!\r\n");
		printf("\r\n");
		if (pf_mount(&Fs) ) continue;	/* Initialize FS */
		//lcd_text(0,3, "initialized");
		//__delay_ms(100);
		printf( "initialized\r\n");
		
		while(1){
			if (pf_opendir(&Dir, "")) break;
			while (!pf_readdir(&Dir, &Fno) && Fno.fname[0]) {
				if( strstr(Fno.fname, ".TXT") ){			// TXT file
					//lcd_clear();
					//lcd_gotoxy(0,0);
					//lcd_puts2(Fno.fname);
					printf(Fno.fname);
					printf("\r\n");
					if(pf_open(Fno.fname)) continue;		// open file
					if( strstr(Fno.fname, "BLANK") ){
						//lcd_gotoxy(0,1);
						//lcd_puts("writing to a blank file");	// (PFF note: "pf_write" cannot expand file size)
						printf("writing to a blank file\r\n");
						if(pf_write("sample message to SD/MMC card.\r\n", 0, &rb)) continue;	// write to file
						if(pf_write(0, 0, &rb)) continue;		// Finalize the write process
						//lcd_puts("     done.");
						printf("     done.\r\n");
					}
					else{
						if(pf_read(buff, 70, &rb)) continue;    // Read data to the buff[]
						//lcd_gotoxy(0,1);
						//lcd_puts2(buff);	// display txt file content
						printf(buff);
					    printf("\r\n");
						for(i=0; i<100; i++) buff[i]=0;			// clear buffer
					}
					delay();
					delay();
					delay();
				}
			}
		}
		
	}
}

void delay(void)
{
	long i=0x1FFFF;
	while(--i);
}
