#ifndef _LCD3310
#define _LCD3310

#define LCD_CLK		LATA0
#define	LCD_DATA	LATA1
#define	LCD_DC		LATA2
#define	LCD_CE		LATA3
#define	LCD_RESET	LATA5
#define LCD_TRIS()	TRISA &= 0b11010000

#define BIT7 0b10000000
#define BIT6 0b01000000
#define BIT5 0b00100000
#define BIT4 0b00010000
#define BIT3 0b00001000
#define BIT2 0b00000100
#define BIT1 0b00000010
#define BIT0 0b00000001

#define LCD_TCMD	0
#define	LCD_TDATA	1


unsigned char lcd_str_width(const unsigned char *c);
void lcd_send(unsigned char a, unsigned char cmd);
void lcd_init(void);
void lcd_test(void);
void lcd_clear(void);
void lcd_gotoxy(unsigned char x, unsigned y);
void lcd_putch(unsigned char c);
void lcd_puts(const char *s);
void lcd_puts2(char *s);
void lcd_clear_line(unsigned char y);

void lcd_text(unsigned char x, unsigned y, const char *s);

#endif	// _LCD3310
