#include <pic18.h>
#include "usart.h"
#include <stdio.h>

void interrupt ISR(void)
{
	if((RBIE)&&(RBIF))
	{
													
		if(USART_RC)		RCIE=1;//!RCIE;					/*turn USART receive interrupt on and off*/
		else		RCIE=0;

		if(USART_TX)		TX_INT=1;//!TX_INT;			/*use other variable rather than TXIE, so that printf() routine can be used by the program*/
		else		TX_INT=0;									/*TXIE is set only when keyboard input is expected*/

		RBIF=0;
		UPDATE_REQUIRED=1;
	}
	if((RCIE)&&(RCIF))										/*receive interrupt routine*/
	{
		DATA=RCREG;
		DATA_RECEIVED=1;								/*indicate that some data has been received*/
	}	

	if((TXIE)&&(TXIF))										/*transmit interrupt routine*/
	{
		TXREG=DATA;
		TXIE=0;
	}	
}

